﻿﻿
## AutomationML Editor PlugIn development

### Version 6.2

**AutomationML Editor** supports the integration of PlugIns.

With the introduction of version 6.0, only plug-ins that support at least .NET 5.0 are supported. PlugIns that have been developed for an older .NET version can no longer be integrated by this version. 

The development tools, used so far for plug-in development, have been extended by additional tools for PlugIn development for editor version 6.0. If you are a PlugIn developer, you can choose the appropriate development platform. V5 developers use the [V5 platform](https://github.com/AutomationML/AMLEditorPlugin/tree/master/PlugInDevelopment_V5). V6 developers use the new [V6 platform](https://github.com/AutomationML/AMLEditorPlugin/tree/master/PlugInDevelopment_V6). The V6 platform also offers new PlugIn examples.

V6 PlugIn Development can use a new [AutomationML Editor API Package](https://www.nuget.org/packages/Aml.Editor.API).


> **PlugIns are licensed by their respective owners. AutomationML assumes no responsibility for third-party PlugIns 
> or grants licenses for third-party PlugIns.**

To be able to implement and deploy PlugIns the following resources are provided:

1. A contract, defining interfaces which are importable by the Editor. The DLL is available at https://www.nuget.org/packages/Aml.Editor.Plugin.Contract/.

2. Detailed documentation, example PlugIns and a Sandbox project supporting tests and deployment, available at https://github.com/AutomationML/AMLEditorPlugin/.

3. A Toolkit, which nicely integrates with the AutomationML editor for viewing of AutomationML structures, available at https://www.nuget.org/packages/Aml.Toolkit/.

PlugIn development is based on the MEF Framework https://docs.microsoft.com/en-us/dotnet/framework/mef/. A basic understanding of this framework is recommended.

Best way to implement a PlugIn is to start with the Sandbox project and one of the contained examples, to get an understanding how PlugIns are developed. 
Own PlugIn developments should start with a copy of one of the provided examples. Modify the code and test the deployment within the Sandbox. The Sandbox mimics the docking and loading behaviour of the AutomationML Editor. If you can load and run your PlugIn in the Sandbox, you should be able to run it in your installed AutomationML Editor - please ensure, that there are no name conflicts with already existing PlugIns. Since **version 5.1.3** of the AutomationML editor, an integrated PlugIn Manager
can be used to install a PlugIn. 
Each PlugIn should be provided in the **`Aml.Editor.Plugin`** namespace and provide an 'About box'. Only those PlugIns may be published to other users. The AutomationML Editors PlugIn Manager will list all
PlugIns, which are published on NuGet and are correctly named using the  **`Aml.Editor.Plugin`** namespace prefix.
